!     ######spl
      MODULE MODI_CONVLO2UP
!     #####################
!
INTERFACE
!
SUBROUTINE CONVLO2UP(HCARIN,HCAROUT)
CHARACTER(LEN=*) :: HCARIN
CHARACTER(LEN=*) :: HCAROUT
END SUBROUTINE CONVLO2UP
!
END INTERFACE
!
END MODULE MODI_CONVLO2UP
!     ######spl
      SUBROUTINE CONVLO2UP(HCARIN,HCAROUT)
!     ####################################
!
!!****  *CONVLO2UP* - 
!!
!!    PURPOSE
!!    -------
!      
!
!!**  METHOD
!!    ------
!!     
!!     N.A.
!!
!!    EXTERNAL
!!    --------
!!      None
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!      Module
!!
!!    REFERENCE
!!    ---------
!!
!!
!!    AUTHOR
!!    ------
!!      J. Duron    * Laboratoire d'Aerologie *
!!
!!
!!    MODIFICATIONS
!!    -------------
!!      Original       06/06/94
!!      Updated   PM   02/12/94
!-------------------------------------------------------------------------------
!
!*       0.    DECLARATIONS
!              ------------
!
USE MODD_FILES_DIACHRO
USE MODD_ALLOC_FORDIACHRO

IMPLICIT NONE
!
!*       0.1   Dummy arguments
!              ---------------

CHARACTER(LEN=*) :: HCARIN
CHARACTER(LEN=*) :: HCAROUT
!
!*       0.1   Local variables
!              ---------------

!
CHARACTER(LEN=LEN_TRIM(HCARIN)) :: YCARIN
CHARACTER(LEN=1),DIMENSION(26),SAVE  :: YLO=(/'a','b','c','d','e','f','g', &
 'h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z'/)
CHARACTER(LEN=1),DIMENSION(26),SAVE  :: YUP=(/'A','B','C','D','E','F','G', & 
 'H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'/)
INTEGER   ::   ILENC
INTEGER   ::   INDCAR
INTEGER   ::   INDTIT, INDPVMIN, INDPVMAX, INDFTMIN, INDFTMAX 
INTEGER   ::   INDPVKTMIN, INDPVKTMAX
INTEGER   ::   INDISOMIN, INDISOMAX, INDDIAINT, INDISOREF
INTEGER   ::   INDFT1MIN, INDFT1MAX, INDISOLEV
               
INTEGER   ::   J, JA, IBEG, IEND, JJ
!------------------------------------------------------------------------------
!
NBGUIL=0
HCAROUT(1:LEN(HCAROUT))=' '
YCARIN = HCARIN
ILENC = LEN(YCARIN)
!print *,' HCARIN ',LEN(HCARIN)
!print *,HCARIN
DO J=1,ILENC
  DO JA=1,26
    IF(YCARIN(J:J) == YLO(JA))YCARIN(J:J)=YUP(JA)
  ENDDO
ENDDO
!print *,' YCARIN ',YCARIN
INDCAR=INDEX(YCARIN,'CSYMCAR')
IF(INDCAR /= 0)THEN
  IF(YCARIN(INDCAR:INDCAR+6)=='CSYMCAR')THEN
    HCARIN(INDCAR:INDCAR+6)=YCARIN(INDCAR:INDCAR+6)
    HCAROUT=HCARIN
    HCAROUT=ADJUSTL(HCAROUT)
    RETURN
  ENDIF
ENDIF
INDCAR=INDEX(YCARIN,'CNOMCAR')
IF(INDCAR /= 0)THEN
  IF(YCARIN(INDCAR:INDCAR+6)=='CNOMCAR')THEN
    HCARIN(INDCAR:INDCAR+6)=YCARIN(INDCAR:INDCAR+6)
    HCAROUT=HCARIN
    HCAROUT=ADJUSTL(HCAROUT)
    RETURN
  ENDIF
ENDIF

INDTIT=INDEX(YCARIN,'CTIT')

IF(INDTIT /= 0)THEN

IF(YCARIN(INDTIT:INDTIT+5)=='CTITT1' .OR. YCARIN(INDTIT:INDTIT+5)=='CTITT2'.OR.&
   YCARIN(INDTIT:INDTIT+5)=='CTITT3' .OR. YCARIN(INDTIT:INDTIT+5)=='CTITB1'.OR.&
   YCARIN(INDTIT:INDTIT+5)=='CTITB2' .OR. YCARIN(INDTIT:INDTIT+5)=='CTITB3'.OR.&
   YCARIN(INDTIT:INDTIT+5)=='CTITYT' .OR. YCARIN(INDTIT:INDTIT+5)=='CTITYM'.OR.&
   YCARIN(INDTIT:INDTIT+5)=='CTITYB' .OR. YCARIN(INDTIT:INDTIT+5)=='CTITXL'.OR.&
   YCARIN(INDTIT:INDTIT+5)=='CTITXM' .OR. YCARIN(INDTIT:INDTIT+5)=='CTITXR')THEN
!print *,' HCARIN ',HCARIN
   HCARIN(INDTIT:INDTIT+5)=YCARIN(INDTIT:INDTIT+5)
!  HCAROUT=ADJUSTL(HCARIN)
   HCAROUT=HCARIN
   HCAROUT=ADJUSTL(HCAROUT)
!print *,' HCARIN ',HCARIN
!print *,' HCAROUT ',HCAROUT
   RETURN
ENDIF
IF(YCARIN(INDTIT:INDTIT+7)=='CTITVAR1' .OR. YCARIN(INDTIT:INDTIT+7)=='CTITVAR2'.OR.&
   YCARIN(INDTIT:INDTIT+7)=='CTITVAR3' .OR. YCARIN(INDTIT:INDTIT+7)=='CTITVAR4'.OR.&
   YCARIN(INDTIT:INDTIT+7)=='CTITVAR5' .OR. YCARIN(INDTIT:INDTIT+7)=='CTITVAR6'.OR.&
   YCARIN(INDTIT:INDTIT+7)=='CTITVAR7' .OR. YCARIN(INDTIT:INDTIT+7)=='CTITVAR8')THEN
!print *,' HCARIN ',HCARIN
   HCARIN(INDTIT:INDTIT+7)=YCARIN(INDTIT:INDTIT+7)
!  HCAROUT=ADJUSTL(HCARIN)
   HCAROUT=HCARIN
   HCAROUT=ADJUSTL(HCAROUT)
!print *,' HCARIN ',HCARIN
!print *,' HCAROUT ',HCAROUT
   RETURN
ENDIF

ENDIF
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
INDTIT=INDEX(YCARIN,'CFT1TIT')
!
IF(INDTIT /= 0)THEN
!
IF(YCARIN(INDTIT:INDTIT+7)=='CFT1TIT1' .OR. YCARIN(INDTIT:INDTIT+7)=='CFT1TIT2'.OR.&
   YCARIN(INDTIT:INDTIT+7)=='CFT1TIT3' .OR. YCARIN(INDTIT:INDTIT+7)=='CFT1TIT4'.OR.&
   YCARIN(INDTIT:INDTIT+7)=='CFT1TIT5' .OR. YCARIN(INDTIT:INDTIT+7)=='CFT1TIT6'.OR.&
   YCARIN(INDTIT:INDTIT+7)=='CFT1TIT7' .OR. YCARIN(INDTIT:INDTIT+7)=='CFT1TIT8'.OR.&
   YCARIN(INDTIT:INDTIT+7)=='CFT1TIT9')THEN

   HCARIN(INDTIT:INDTIT+7)=YCARIN(INDTIT:INDTIT+7)
   HCAROUT=HCARIN
   HCAROUT=ADJUSTL(HCAROUT)
!print *,' HCARIN ',HCARIN
!print *,' HCAROUT ',HCAROUT
   RETURN
ENDIF
IF(YCARIN(INDTIT:INDTIT+8)=='CFT1TIT10'.OR.&
   YCARIN(INDTIT:INDTIT+8)=='CFT1TIT11' .OR. YCARIN(INDTIT:INDTIT+8)=='CFT1TIT12' .OR. &
   YCARIN(INDTIT:INDTIT+8)=='CFT1TIT13' .OR. YCARIN(INDTIT:INDTIT+8)=='CFT1TIT14' .OR. &
   YCARIN(INDTIT:INDTIT+8)=='CFT1TIT15' )THEN

   HCARIN(INDTIT:INDTIT+8)=YCARIN(INDTIT:INDTIT+8)
   HCAROUT=HCARIN
   HCAROUT=ADJUSTL(HCAROUT)
!print *,' HCARIN ',HCARIN
!print *,' HCAROUT ',HCAROUT
   RETURN
ENDIF
!
ENDIF
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
INDTIT=INDEX(YCARIN,'CVARNPV')
!
IF(INDTIT /= 0)THEN
!
IF(YCARIN(INDTIT:INDTIT+7)=='CVARNPV1' .OR. YCARIN(INDTIT:INDTIT+7)=='CVARNPV2'.OR.&
   YCARIN(INDTIT:INDTIT+7)=='CVARNPV3' .OR. YCARIN(INDTIT:INDTIT+7)=='CVARNPV4'.OR.&
   YCARIN(INDTIT:INDTIT+7)=='CVARNPV5' .OR. YCARIN(INDTIT:INDTIT+7)=='CVARNPV6'.OR.&
   YCARIN(INDTIT:INDTIT+7)=='CVARNPV7' .OR. YCARIN(INDTIT:INDTIT+7)=='CVARNPV8'.OR.&
   YCARIN(INDTIT:INDTIT+7)=='CVARNPV9')THEN

   HCARIN(INDTIT:INDTIT+7)=YCARIN(INDTIT:INDTIT+7)
   HCAROUT=HCARIN
   HCAROUT=ADJUSTL(HCAROUT)
!print *,' HCARIN ',HCARIN
!print *,' HCAROUT ',HCAROUT
   RETURN
ENDIF
IF(YCARIN(INDTIT:INDTIT+8)=='CVARNPV10'.OR.&
   YCARIN(INDTIT:INDTIT+8)=='CVARNPV11' .OR. YCARIN(INDTIT:INDTIT+8)=='CVARNPV12' .OR. &
   YCARIN(INDTIT:INDTIT+8)=='CVARNPV13' .OR. YCARIN(INDTIT:INDTIT+8)=='CVARNPV14' .OR. &
   YCARIN(INDTIT:INDTIT+8)=='CVARNPV15' )THEN

   HCARIN(INDTIT:INDTIT+8)=YCARIN(INDTIT:INDTIT+8)
   HCAROUT=HCARIN
   HCAROUT=ADJUSTL(HCAROUT)
!print *,' HCARIN ',HCARIN
!print *,' HCAROUT ',HCAROUT
   RETURN
ENDIF
!
ENDIF
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
INDTIT=INDEX(YCARIN,'CVARNPH')
!
IF(INDTIT /= 0)THEN
!
IF(YCARIN(INDTIT:INDTIT+7)=='CVARNPH1' .OR. YCARIN(INDTIT:INDTIT+7)=='CVARNPH2'.OR.&
   YCARIN(INDTIT:INDTIT+7)=='CVARNPH3' .OR. YCARIN(INDTIT:INDTIT+7)=='CVARNPH4'.OR.&
   YCARIN(INDTIT:INDTIT+7)=='CVARNPH5' .OR. YCARIN(INDTIT:INDTIT+7)=='CVARNPH6'.OR.&
   YCARIN(INDTIT:INDTIT+7)=='CVARNPH7' .OR. YCARIN(INDTIT:INDTIT+7)=='CVARNPH8')THEN

   HCARIN(INDTIT:INDTIT+7)=YCARIN(INDTIT:INDTIT+7)
   HCAROUT=HCARIN
   HCAROUT=ADJUSTL(HCAROUT)
   RETURN
ENDIF
ENDIF
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
INDPVMIN=INDEX(YCARIN,'XPVMIN_')
IF(INDPVMIN /= 0)THEN
! HCARIN(INDPVMIN:INDPVMIN+6)=YCARIN(INDPVMIN:INDPVMIN+6)
  DO J=INDPVMIN+6,ILENC
    IF(HCARIN(J:J) == ' ' .OR. HCARIN(J:J) == '=')THEN
      YCARIN(INDPVMIN+6:J)=HCARIN(INDPVMIN+6:J)
      EXIT
    ENDIF
  ENDDO
ENDIF
INDFTMIN=INDEX(YCARIN,'XFTMIN_')
IF(INDFTMIN /= 0)THEN
! HCARIN(INDFTMIN:INDFTMIN+6)=YCARIN(INDFTMIN:INDFTMIN+6)
  DO J=INDFTMIN+6,ILENC
    IF(HCARIN(J:J) == ' ' .OR. HCARIN(J:J) == '=')THEN
      YCARIN(INDFTMIN+6:J)=HCARIN(INDFTMIN+6:J)
      EXIT
    ENDIF
  ENDDO
ENDIF
INDFT1MIN=INDEX(YCARIN,'XFT1MIN_')
IF(INDFT1MIN /= 0)THEN
! HCARIN(INDFT1MIN:INDFT1MIN+7)=YCARIN(INDFT1MIN:INDFT1MIN+7)
  DO J=INDFT1MIN+7,ILENC
    IF(HCARIN(J:J) == ' ' .OR. HCARIN(J:J) == '=')THEN
      YCARIN(INDFT1MIN+7:J)=HCARIN(INDFT1MIN+7:J)
      EXIT
    ENDIF
  ENDDO
ENDIF
INDPVKTMIN=INDEX(YCARIN,'XPVKTMIN_')
IF(INDPVKTMIN /= 0)THEN
! HCARIN(INDPVKTMIN:INDPVKTMIN+8)=YCARIN(INDPVKTMIN:INDPVKTMIN+8)
  DO J=INDPVKTMIN+8,ILENC
    IF(HCARIN(J:J) == ' ' .OR. HCARIN(J:J) == '=')THEN
      YCARIN(INDPVKTMIN+8:J)=HCARIN(INDPVKTMIN+8:J)
      EXIT
    ENDIF
  ENDDO
ENDIF
INDPVMAX=INDEX(YCARIN,'XPVMAX_')
IF(INDPVMAX /= 0)THEN
! HCARIN(INDPVMAX:INDPVMAX+6)=YCARIN(INDPVMAX:INDPVMAX+6)
  DO J=INDPVMAX+6,ILENC
    IF(HCARIN(J:J) == ' ' .OR. HCARIN(J:J) == '=')THEN
      YCARIN(INDPVMAX+6:J)=HCARIN(INDPVMAX+6:J)
      EXIT
    ENDIF
  ENDDO
ENDIF
INDFTMAX=INDEX(YCARIN,'XFTMAX_')
IF(INDFTMAX /= 0)THEN
! HCARIN(INDFTMAX:INDFTMAX+6)=YCARIN(INDFTMAX:INDFTMAX+6)
  DO J=INDFTMAX+6,ILENC
    IF(HCARIN(J:J) == ' ' .OR. HCARIN(J:J) == '=')THEN
      YCARIN(INDFTMAX+6:J)=HCARIN(INDFTMAX+6:J)
      EXIT
    ENDIF
  ENDDO
ENDIF
INDFT1MAX=INDEX(YCARIN,'XFT1MAX_')
IF(INDFT1MAX /= 0)THEN
! HCARIN(INDFT1MAX:INDFT1MAX+7)=YCARIN(INDFT1MAX:INDFT1MAX+7)
  DO J=INDFT1MAX+7,ILENC
    IF(HCARIN(J:J) == ' ' .OR. HCARIN(J:J) == '=')THEN
      YCARIN(INDFT1MAX+7:J)=HCARIN(INDFT1MAX+7:J)
      EXIT
    ENDIF
  ENDDO
ENDIF
INDPVKTMAX=INDEX(YCARIN,'XPVKTMAX_')
IF(INDPVKTMAX /= 0)THEN
! HCARIN(INDPVKTMAX:INDPVKTMAX+8)=YCARIN(INDPVKTMAX:INDPVKTMAX+8)
  DO J=INDPVKTMAX+8,ILENC
    IF(HCARIN(J:J) == ' ' .OR. HCARIN(J:J) == '=')THEN
      YCARIN(INDPVKTMAX+8:J)=HCARIN(INDPVKTMAX+8:J)
      EXIT
    ENDIF
  ENDDO
ENDIF
INDISOMIN=INDEX(YCARIN,'XISOMIN_')
IF(INDISOMIN /= 0)THEN
! HCARIN(INDISOMIN:INDISOMIN+7)=YCARIN(INDISOMIN:INDISOMIN+7)
  DO J=INDISOMIN+7,ILENC
    IF(HCARIN(J:J) == ' ' .OR. HCARIN(J:J) == '=')THEN
      YCARIN(INDISOMIN+7:J)=HCARIN(INDISOMIN+7:J)
      EXIT
    ENDIF
  ENDDO
ENDIF
INDISOMAX=INDEX(YCARIN,'XISOMAX_')
IF(INDISOMAX /= 0)THEN
! HCARIN(INDISOMAX:INDISOMAX+7)=YCARIN(INDISOMAX:INDISOMAX+7)
  DO J=INDISOMAX+7,ILENC
    IF(HCARIN(J:J) == ' ' .OR. HCARIN(J:J) == '=')THEN
      YCARIN(INDISOMAX+7:J)=HCARIN(INDISOMAX+7:J)
      EXIT
    ENDIF
  ENDDO
ENDIF
INDDIAINT=INDEX(YCARIN,'XDIAINT_')
IF(INDDIAINT /= 0)THEN
! HCARIN(INDDIAINT:INDDIAINT+7)=YCARIN(INDDIAINT:INDDIAINT+7)
  DO J=INDDIAINT+7,ILENC
    IF(HCARIN(J:J) == ' ' .OR. HCARIN(J:J) == '=')THEN
      YCARIN(INDDIAINT+7:J)=HCARIN(INDDIAINT+7:J)
      EXIT
    ENDIF
  ENDDO
ENDIF
INDISOREF=INDEX(YCARIN,'XISOREF_')
IF(INDISOREF /= 0)THEN
  DO J=INDISOREF+7,ILENC
    IF(HCARIN(J:J) == ' ' .OR. HCARIN(J:J) == '=')THEN
      YCARIN(INDISOREF+7:J)=HCARIN(INDISOREF+7:J)
      EXIT
    ENDIF
  ENDDO
ENDIF
INDISOLEV=INDEX(YCARIN,'XISOLEV_')
IF(INDISOLEV /= 0)THEN
  DO J=INDISOLEV+7,ILENC
    IF(HCARIN(J:J) == ' ' .OR. HCARIN(J:J) == '=')THEN
      YCARIN(INDISOLEV+7:J)=HCARIN(INDISOLEV+7:J)
      EXIT
    ENDIF
  ENDDO
ENDIF
IF(INDPVMIN + INDPVMAX + INDFTMIN + INDFTMAX + INDPVKTMIN + &
   INDPVKTMAX  + INDISOMIN + INDISOMAX + INDDIAINT + INDISOREF + &
   INDFT1MIN + INDFT1MAX + INDISOLEV /= 0)THEN
!  HCAROUT=ADJUSTL(YCARIN)
   HCAROUT=YCARIN
   HCAROUT=ADJUSTL(HCAROUT)
  RETURN
ENDIF

YCARIN = HCARIN

!print *,' YCARIN ILENC ',ILENC,YCARIN

NBGUIL=0

DO J = 1,ILENC
  IF(YCARIN(J:J) == '"')THEN
    NBGUIL=NBGUIL+1
    NMGUIL(NBGUIL)=J
  ENDIF
  IF(YCARIN(J:J) == "'")THEN
    NBGUIL=NBGUIL+1
    NMGUIL(NBGUIL)=J
  ENDIF
ENDDO
IF(MOD(NBGUIL,2) /= 0)THEN
  print *,' NB DE GUILLEMETS ET(/OU) DE QUOTES IMPAIR. VERIFIEZ LA SYNTAXE DE VOS', &
  ' INSTRUCTIONS D ENTREE'
  LPBREAD=.TRUE.
  RETURN
! STOP
ENDIF
NMGUIL(NBGUIL+1)=ILENC+1
!
DO J=1,NBGUIL+1,2
  IF(J == 1)THEN
    IBEG=1
    IEND=NMGUIL(J)-1
  ELSE IF(J == NBGUIL+1)THEN
    IBEG=MIN(NMGUIL(J-1)+1,ILENC)
    IEND=ILENC
  ELSE
    IBEG=NMGUIL(J-1)+1
    IEND=NMGUIL(J)-1
  END IF
! print *,' ibeg iend ilenc ycarin ',ibeg,iend,ilenc
! print *,ycarin(ibeg:iend)
DO JJ=IBEG,IEND
  DO JA=1,26
    IF(YCARIN(JJ:JJ) == YLO(JA))YCARIN(JJ:JJ)=YUP(JA)
  ENDDO
ENDDO
ENDDO
!HCAROUT=ADJUSTL(YCARIN)
HCAROUT=YCARIN
HCAROUT=ADJUSTL(HCAROUT)
!
!-----------------------------------------------------------------------------
!
!*       2.       EXITS
!                 -----
! 
!print *,' ** sortie convlo2up'
RETURN
END SUBROUTINE CONVLO2UP
