!     ######spl
      SUBROUTINE LOAD_EXPR(KIND,HCARIN)
!     ################################
!
!!****  *LOAD_FMTAXES* - 
!!
!!    PURPOSE
!!    -------
!       Analyser l'expression a mutiplier ou diviser (actuellement un  
!       processus) et le charger en memoire pour le calcul ulterieur
!
!!**  METHOD
!!    ------
!!     
!!     N.A.
!!
!!    EXTERNAL
!!    --------
!!      None
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!      Module
!!
!!      Module
!!
!!    REFERENCE
!!    ---------
!!
!!
!!    AUTHOR
!!    ------
!!      J. Duron    * Laboratoire d'Aerologie *
!!
!!
!!    MODIFICATIONS
!!    -------------
!!      Original       02/07/01
!!      Updated   PM   
!-------------------------------------------------------------------------------
!
!*       0.    DECLARATIONS
!              ------------
!
USE MODD_EXPR
USE MODN_NCAR
USE MODD_FILES_DIACHRO
USE MODD_ALLOC_FORDIACHRO
USE MODD_SEVERAL_RECORDS

IMPLICIT NONE
!
!*       0.1   Dummy arguments
!              ---------------

INTEGER          :: KIND
CHARACTER(LEN=*) :: HCARIN
!
!*       0.1   Local variables
!              ---------------
CHARACTER(LEN=LEN(HCARIN)) :: YCARIN
CHARACTER(LEN=20) :: YTEM
CHARACTER(LEN=16) :: YGROUP
CHARACTER(LEN=1) :: YSTAR
INTEGER,SAVE     :: INDEXPR, ILEN, IPARG, IPARD, IETOILE,IMULT
INTEGER,SAVE     :: IEGAL, J,JM, IP, IPR
INTEGER          :: INDPLUS, INDMINUS
REAL,SAVE        :: ZCONSTANTE
! !------------------------------------------------------------------------------
!*********************************************
! Cas RM*EXPRx (RM/EXPRx) et *EXPRx= (/EXPRx=)
!*********************************************
IF(KIND == 0)THEN
  INDEXPR=INDEX(HCARIN,'RM*')
  IF(INDEXPR /= 0)THEN
! RM*EXPRx
!!!!!!!!!!
    IF(HCARIN == 'RM*EXPR1')THEN
      IF(ALLOCATED(XEXPR1))DEALLOCATE(XEXPR1)
    ELSE IF(HCARIN == 'RM*EXPR2')THEN
      IF(ALLOCATED(XEXPR2))DEALLOCATE(XEXPR2)
    ELSE IF(HCARIN == 'RM*EXPR3')THEN
      IF(ALLOCATED(XEXPR3))DEALLOCATE(XEXPR3)
    ELSE IF(HCARIN == 'RM*EXPR4')THEN
      IF(ALLOCATED(XEXPR4))DEALLOCATE(XEXPR4)
    ELSE IF(HCARIN == 'RM*EXPR5')THEN
      IF(ALLOCATED(XEXPR5))DEALLOCATE(XEXPR5)
    ELSE IF(HCARIN == 'RM*EXPR6')THEN
      IF(ALLOCATED(XEXPR6))DEALLOCATE(XEXPR6)
    ELSE IF(HCARIN == 'RM*EXPR7')THEN
      IF(ALLOCATED(XEXPR7))DEALLOCATE(XEXPR7)
    ELSE IF(HCARIN == 'RM*EXPR8')THEN
      IF(ALLOCATED(XEXPR8))DEALLOCATE(XEXPR8)
    ELSE IF(HCARIN == 'RM*EXPR9')THEN
      IF(ALLOCATED(XEXPR9))DEALLOCATE(XEXPR9)
    ENDIF
  ELSE
    INDEXPR=INDEX(HCARIN,'RM/')
    IF(INDEXPR /= 0)THEN
! RM/EXPRx
!!!!!!!!!!
      IF(HCARIN == 'RM/EXPR1')THEN
        IF(ALLOCATED(XDEXPR1))DEALLOCATE(XDEXPR1)
      ELSE IF(HCARIN == 'RM/EXPR2')THEN
        IF(ALLOCATED(XDEXPR2))DEALLOCATE(XDEXPR2)
      ELSE IF(HCARIN == 'RM/EXPR3')THEN
        IF(ALLOCATED(XDEXPR3))DEALLOCATE(XDEXPR3)
      ELSE IF(HCARIN == 'RM/EXPR4')THEN
        IF(ALLOCATED(XDEXPR4))DEALLOCATE(XDEXPR4)
      ELSE IF(HCARIN == 'RM/EXPR5')THEN
        IF(ALLOCATED(XDEXPR5))DEALLOCATE(XDEXPR5)
      ELSE IF(HCARIN == 'RM/EXPR6')THEN
        IF(ALLOCATED(XDEXPR6))DEALLOCATE(XDEXPR6)
      ELSE IF(HCARIN == 'RM/EXPR7')THEN
        IF(ALLOCATED(XDEXPR7))DEALLOCATE(XDEXPR7)
      ELSE IF(HCARIN == 'RM/EXPR8')THEN
        IF(ALLOCATED(XDEXPR8))DEALLOCATE(XDEXPR8)
      ELSE IF(HCARIN == 'RM/EXPR9')THEN
        IF(ALLOCATED(XDEXPR9))DEALLOCATE(XDEXPR9)
      ENDIF
    ELSE
! *EXPRx= ou /EXPRx=
!!!!!!!!!!!!!!!!!!!!
! *EXPRx=
!!!!!!!!!
! /EXPRx=
!!!!!!!!!
      YCARIN(1:LEN(YCARIN))=' '
      INDEXPR=INDEX(HCARIN,'*EXPR')

      IF(INDEXPR == 0)THEN
	INDEXPR=INDEX(HCARIN,'/EXPR')
	YSTAR='*'
      ELSE
	YSTAR='*'
      ENDIF

	INDEXPR=INDEX(HCARIN,'=')
	IEGAL=INDEX(HCARIN,'=')
! Extraction du champ
        YCARIN=HCARIN(INDEXPR+1:LEN_TRIM(HCARIN))
	YCARIN=ADJUSTL(YCARIN)
	ILEN=LEN_TRIM(YCARIN)
! Eventuelle constante a * ou +
	IPARG=INDEX(YCARIN,'(')
! Eventuel autre champ a - ou +
        INDPLUS= INDEX(YCARIN,'_PLUS_')
        INDMINUS= INDEX(YCARIN,'_MINUS_')
	YTEM(1:LEN(YTEM))=' '

	IF(IPARG /= 0)THEN
	  IPARD=INDEX(YCARIN,')')
	  IETOILE=INDEX(YCARIN(IPARG:IPARD),YSTAR)
	  ZCONSTANTE=0
	  IF(IETOILE /= 0)THEN
! Multiplication par une constante
            IMULT=2
	    READ(YCARIN(IETOILE+IPARG:IPARD-1),*)ZCONSTANTE
	    YTEM(1:IPARG-1)=YCARIN(1:IPARG-1)
	    YTEM(IPARG:IPARG+ILEN-IPARD)=YCARIN(IPARD+1:ILEN)
	  ELSE
! Addition d'une constante
            IMULT=1
            READ(YCARIN(IPARG+1:IPARD-1),*)ZCONSTANTE
            YTEM(1:IPARG-1)=YCARIN(1:IPARG-1)
            YTEM(IPARG:IPARG+ILEN-IPARD)=YCARIN(IPARD+1:ILEN)
          ENDIF
        ELSE IF(INDPLUS /= 0)THEN
	  IMULT=0
! Addition d'un autre champ
          YTEM(1:INDPLUS-1)=YCARIN(1:INDPLUS-1)
        ELSE IF(INDMINUS /= 0)THEN
	  IMULT=0
! Soustraction d'un autre champ
	  YTEM(1:INDMINUS-1)=YCARIN(1:INDMINUS-1)
        ELSE
! Pas de cste
	  IMULT=0
	  YTEM(1:ILEN)=YCARIN(1:ILEN)
	ENDIF
	YTEM=ADJUSTL(YTEM)
	print *,' ** load_expr IMULT,zconstante YTEM ',IMULT,zconstante,YTEM
	ILEN=LEN_TRIM(YTEM)
	INDEXPR=INDEX(YTEM,'_P_')
	YGROUP(1:LEN(YGROUP))=' '
	IF(INDEXPR == 0)THEN
  	  YGROUP=YTEM(1:ILEN)
        ELSE
  	  YGROUP=YTEM(1:INDEXPR-1)
        ENDIF
	YGROUP=ADJUSTL(YGROUP)
	IF(INDEXPR == 0)THEN
          IP=1
        ELSE
	READ(YTEM(INDEXPR+3:ILEN),*)IP
        ENDIF
	DO J=1,NBFILES
	  IF(NUMFILES(J) == NUMFILECUR)THEN
	    JM=J
	  ENDIF
	ENDDO
	CALL VERIF_GROUP(CFILEDIAS(JM),CLUOUTDIAS(JM),YGROUP)
	IF(LPBREAD)THEN
	  LPBREAD=.FALSE.
	  print *, ' ** load_expr PB avec le nom du groupe ',YGROUP
	  IF(ALLOCATED(XVAR))THEN
	    CALL ALLOC_FORDIACHRO(1,1,1,1,1,1,3)
	  ENDIF
	  RETURN
	ENDIF
	IF(LGROUP)THEN
	  CALL READ_DIACHRO(CFILEDIAS(JM),CLUOUTDIAS(JM),YGROUP)
	ENDIF
	IF(IP > SIZE(XVAR,6))THEN
	  print *, ' ** load_expr PB avec le numero de processus :',IP, &
	  ' > au nb de processus du groupe: ',SIZE(XVAR,6),'. Corrigez.'
	  IF(ALLOCATED(XVAR))THEN
	    CALL ALLOC_FORDIACHRO(1,1,1,1,1,1,3)
	  ENDIF
	  RETURN
	ENDIF
	ILEN=LEN_TRIM(YCARIN)
	IF(HCARIN(1:6) == '*EXPR1')THEN
	  IF(ALLOCATED(XEXPR1))DEALLOCATE(XEXPR1)
	  ALLOCATE(XEXPR1(SIZE(XVAR,1),SIZE(XVAR,2),SIZE(XVAR,3),&
	  SIZE(XVAR,4),SIZE(XVAR,5),1))
          CALL LOAD_EXPRX(XEXPR1)
	ELSE IF(HCARIN(1:6) == '*EXPR2')THEN
	  IF(ALLOCATED(XEXPR2))DEALLOCATE(XEXPR2)
	  ALLOCATE(XEXPR2(SIZE(XVAR,1),SIZE(XVAR,2),SIZE(XVAR,3),&
	  SIZE(XVAR,4),SIZE(XVAR,5),1))
          CALL LOAD_EXPRX(XEXPR2)
	ELSE IF(HCARIN(1:6) == '*EXPR3')THEN
	  IF(ALLOCATED(XEXPR3))DEALLOCATE(XEXPR3)
	  ALLOCATE(XEXPR3(SIZE(XVAR,1),SIZE(XVAR,2),SIZE(XVAR,3),&
	  SIZE(XVAR,4),SIZE(XVAR,5),1))
          CALL LOAD_EXPRX(XEXPR3)
	ELSE IF(HCARIN(1:6) == '*EXPR4')THEN
	  IF(ALLOCATED(XEXPR4))DEALLOCATE(XEXPR4)
	  ALLOCATE(XEXPR4(SIZE(XVAR,1),SIZE(XVAR,2),SIZE(XVAR,3),&
	  SIZE(XVAR,4),SIZE(XVAR,5),1))
          CALL LOAD_EXPRX(XEXPR4)
	ELSE IF(HCARIN(1:6) == '*EXPR5')THEN
	  IF(ALLOCATED(XEXPR5))DEALLOCATE(XEXPR5)
	  ALLOCATE(XEXPR5(SIZE(XVAR,1),SIZE(XVAR,2),SIZE(XVAR,3),&
	  SIZE(XVAR,4),SIZE(XVAR,5),1))
          CALL LOAD_EXPRX(XEXPR5)
	ELSE IF(HCARIN(1:6) == '*EXPR6')THEN
	  IF(ALLOCATED(XEXPR6))DEALLOCATE(XEXPR6)
	  ALLOCATE(XEXPR6(SIZE(XVAR,1),SIZE(XVAR,2),SIZE(XVAR,3),&
	  SIZE(XVAR,4),SIZE(XVAR,5),1))
          CALL LOAD_EXPRX(XEXPR6)
	ELSE IF(HCARIN(1:6) == '*EXPR7')THEN
	  IF(ALLOCATED(XEXPR7))DEALLOCATE(XEXPR7)
	  ALLOCATE(XEXPR7(SIZE(XVAR,1),SIZE(XVAR,2),SIZE(XVAR,3),&
	  SIZE(XVAR,4),SIZE(XVAR,5),1))
          CALL LOAD_EXPRX(XEXPR7)
	ELSE IF(HCARIN(1:6) == '*EXPR8')THEN
	  IF(ALLOCATED(XEXPR8))DEALLOCATE(XEXPR8)
	  ALLOCATE(XEXPR8(SIZE(XVAR,1),SIZE(XVAR,2),SIZE(XVAR,3),&
	  SIZE(XVAR,4),SIZE(XVAR,5),1))
	  XEXPR8(:,:,:,:,:,1)=XVAR(:,:,:,:,:,IP)
          CALL LOAD_EXPRX(XEXPR8)
	ELSE IF(HCARIN(1:6) == '*EXPR9')THEN
	  IF(ALLOCATED(XEXPR9))DEALLOCATE(XEXPR9)
	  ALLOCATE(XEXPR9(SIZE(XVAR,1),SIZE(XVAR,2),SIZE(XVAR,3),&
	  SIZE(XVAR,4),SIZE(XVAR,5),1))
          CALL LOAD_EXPRX(XEXPR9)
!
	ELSE IF(HCARIN(1:6) == '/EXPR1')THEN
	  IF(ALLOCATED(XDEXPR1))DEALLOCATE(XDEXPR1)
	  ALLOCATE(XDEXPR1(SIZE(XVAR,1),SIZE(XVAR,2),SIZE(XVAR,3),&
	  SIZE(XVAR,4),SIZE(XVAR,5),1))
          CALL LOAD_EXPR1X(XDEXPR1)
	ELSE IF(HCARIN(1:6) == '/EXPR2')THEN
	  IF(ALLOCATED(XDEXPR2))DEALLOCATE(XDEXPR2)
	  ALLOCATE(XDEXPR2(SIZE(XVAR,1),SIZE(XVAR,2),SIZE(XVAR,3),&
	  SIZE(XVAR,4),SIZE(XVAR,5),1))
          CALL LOAD_EXPR1X(XDEXPR2)
	ELSE IF(HCARIN(1:6) == '/EXPR3')THEN
	  IF(ALLOCATED(XDEXPR3))DEALLOCATE(XDEXPR3)
	  ALLOCATE(XDEXPR3(SIZE(XVAR,1),SIZE(XVAR,2),SIZE(XVAR,3),&
	  SIZE(XVAR,4),SIZE(XVAR,5),1))
          CALL LOAD_EXPR1X(XDEXPR3)
	ELSE IF(HCARIN(1:6) == '/EXPR4')THEN
	  IF(ALLOCATED(XDEXPR4))DEALLOCATE(XDEXPR4)
	  ALLOCATE(XDEXPR4(SIZE(XVAR,1),SIZE(XVAR,2),SIZE(XVAR,3),&
	  SIZE(XVAR,4),SIZE(XVAR,5),1))
          CALL LOAD_EXPR1X(XDEXPR4)
	ELSE IF(HCARIN(1:6) == '/EXPR5')THEN
	  IF(ALLOCATED(XDEXPR5))DEALLOCATE(XDEXPR5)
	  ALLOCATE(XDEXPR5(SIZE(XVAR,1),SIZE(XVAR,2),SIZE(XVAR,3),&
	  SIZE(XVAR,4),SIZE(XVAR,5),1))
          CALL LOAD_EXPR1X(XDEXPR5)
	ELSE IF(HCARIN(1:6) == '/EXPR6')THEN
	  IF(ALLOCATED(XDEXPR6))DEALLOCATE(XDEXPR6)
	  ALLOCATE(XDEXPR6(SIZE(XVAR,1),SIZE(XVAR,2),SIZE(XVAR,3),&
	  SIZE(XVAR,4),SIZE(XVAR,5),1))
          CALL LOAD_EXPR1X(XDEXPR6)
	ELSE IF(HCARIN(1:6) == '/EXPR7')THEN
	  IF(ALLOCATED(XDEXPR7))DEALLOCATE(XDEXPR7)
	  ALLOCATE(XDEXPR7(SIZE(XVAR,1),SIZE(XVAR,2),SIZE(XVAR,3),&
	  SIZE(XVAR,4),SIZE(XVAR,5),1))
          CALL LOAD_EXPR1X(XDEXPR7)
	ELSE IF(HCARIN(1:6) == '/EXPR8')THEN
	  IF(ALLOCATED(XDEXPR8))DEALLOCATE(XDEXPR8)
	  ALLOCATE(XDEXPR8(SIZE(XVAR,1),SIZE(XVAR,2),SIZE(XVAR,3),&
	  SIZE(XVAR,4),SIZE(XVAR,5),1))
          CALL LOAD_EXPR1X(XDEXPR8)
	ELSE IF(HCARIN(1:6) == '/EXPR9')THEN
	  IF(ALLOCATED(XDEXPR9))DEALLOCATE(XDEXPR9)
	  ALLOCATE(XDEXPR9(SIZE(XVAR,1),SIZE(XVAR,2),SIZE(XVAR,3),&
	  SIZE(XVAR,4),SIZE(XVAR,5),1))
          CALL LOAD_EXPR1X(XDEXPR9)
	ENDIF

    ENDIF
  ENDIF
ELSE
!*********************
! Cas *EXPRx (/EXPRx)
!*********************
  IF(HCARIN == '*EXPR1')THEN
    DO IPR=1,SIZE(XVAR,6)
     WHERE(XVAR(:,:,:,:,:,IPR) /= XSPVAL)
       XVAR(:,:,:,:,:,IPR)=XVAR(:,:,:,:,:,IPR)*XEXPR1(:,:,:,:,:,1)
     ENDWHERE
    ENDDO
  ELSE IF(HCARIN == '*EXPR2')THEN
    DO IPR=1,SIZE(XVAR,6)
     WHERE(XVAR(:,:,:,:,:,IPR) /= XSPVAL)
       XVAR(:,:,:,:,:,IPR)=XVAR(:,:,:,:,:,IPR)*XEXPR2(:,:,:,:,:,1)
     ENDWHERE
    ENDDO
  ELSE IF(HCARIN == '*EXPR3')THEN
    DO IPR=1,SIZE(XVAR,6)
     WHERE(XVAR(:,:,:,:,:,IPR) /= XSPVAL)
       XVAR(:,:,:,:,:,IPR)=XVAR(:,:,:,:,:,IPR)*XEXPR3(:,:,:,:,:,1)
     ENDWHERE
    ENDDO
  ELSE IF(HCARIN == '*EXPR4')THEN
    DO IPR=1,SIZE(XVAR,6)
     WHERE(XVAR(:,:,:,:,:,IPR) /= XSPVAL)
       XVAR(:,:,:,:,:,IPR)=XVAR(:,:,:,:,:,IPR)*XEXPR4(:,:,:,:,:,1)
     ENDWHERE
    ENDDO
  ELSE IF(HCARIN == '*EXPR5')THEN
    DO IPR=1,SIZE(XVAR,6)
     WHERE(XVAR(:,:,:,:,:,IPR) /= XSPVAL)
       XVAR(:,:,:,:,:,IPR)=XVAR(:,:,:,:,:,IPR)*XEXPR5(:,:,:,:,:,1)
     ENDWHERE
    ENDDO
  ELSE IF(HCARIN == '*EXPR6')THEN
    DO IPR=1,SIZE(XVAR,6)
     WHERE(XVAR(:,:,:,:,:,IPR) /= XSPVAL)
       XVAR(:,:,:,:,:,IPR)=XVAR(:,:,:,:,:,IPR)*XEXPR6(:,:,:,:,:,1)
     ENDWHERE
    ENDDO
  ELSE IF(HCARIN == '*EXPR7')THEN
    DO IPR=1,SIZE(XVAR,6)
     WHERE(XVAR(:,:,:,:,:,IPR) /= XSPVAL)
       XVAR(:,:,:,:,:,IPR)=XVAR(:,:,:,:,:,IPR)*XEXPR7(:,:,:,:,:,1)
     ENDWHERE
    ENDDO
  ELSE IF(HCARIN == '*EXPR8')THEN
    DO IPR=1,SIZE(XVAR,6)
     WHERE(XVAR(:,:,:,:,:,IPR) /= XSPVAL)
       XVAR(:,:,:,:,:,IPR)=XVAR(:,:,:,:,:,IPR)*XEXPR8(:,:,:,:,:,1)
     ENDWHERE
    ENDDO
  ELSE IF(HCARIN == '*EXPR9')THEN
    DO IPR=1,SIZE(XVAR,6)
     WHERE(XVAR(:,:,:,:,:,IPR) /= XSPVAL)
       XVAR(:,:,:,:,:,IPR)=XVAR(:,:,:,:,:,IPR)*XEXPR9(:,:,:,:,:,1)
     ENDWHERE
    ENDDO

  ELSE IF(HCARIN == '/EXPR1')THEN
    DO IPR=1,SIZE(XVAR,6)
     WHERE(XVAR(:,:,:,:,:,IPR) /= XSPVAL .AND. XDEXPR1(:,:,:,:,:,1) /= XSPVAL)
       XVAR(:,:,:,:,:,IPR)=XVAR(:,:,:,:,:,IPR)*XDEXPR1(:,:,:,:,:,1)
     ELSEWHERE
       XVAR(:,:,:,:,:,IPR)=XSPVAL
    ENDWHERE
    ENDDO
  ELSE IF(HCARIN == '/EXPR2')THEN
    DO IPR=1,SIZE(XVAR,6)
     WHERE(XVAR(:,:,:,:,:,IPR) /= XSPVAL)
       XVAR(:,:,:,:,:,IPR)=XVAR(:,:,:,:,:,IPR)*XDEXPR2(:,:,:,:,:,1)
     ENDWHERE
    ENDDO
  ELSE IF(HCARIN == '/EXPR3')THEN
    DO IPR=1,SIZE(XVAR,6)
     WHERE(XVAR(:,:,:,:,:,IPR) /= XSPVAL)
       XVAR(:,:,:,:,:,IPR)=XVAR(:,:,:,:,:,IPR)*XDEXPR3(:,:,:,:,:,1)
     ENDWHERE
    ENDDO
  ELSE IF(HCARIN == '/EXPR4')THEN
    DO IPR=1,SIZE(XVAR,6)
     WHERE(XVAR(:,:,:,:,:,IPR) /= XSPVAL)
       XVAR(:,:,:,:,:,IPR)=XVAR(:,:,:,:,:,IPR)*XDEXPR4(:,:,:,:,:,1)
     ENDWHERE
    ENDDO
  ELSE IF(HCARIN == '/EXPR5')THEN
    DO IPR=1,SIZE(XVAR,6)
     WHERE(XVAR(:,:,:,:,:,IPR) /= XSPVAL)
       XVAR(:,:,:,:,:,IPR)=XVAR(:,:,:,:,:,IPR)*XDEXPR5(:,:,:,:,:,1)
     ENDWHERE
    ENDDO
  ELSE IF(HCARIN == '/EXPR6')THEN
    DO IPR=1,SIZE(XVAR,6)
     WHERE(XVAR(:,:,:,:,:,IPR) /= XSPVAL)
       XVAR(:,:,:,:,:,IPR)=XVAR(:,:,:,:,:,IPR)*XDEXPR6(:,:,:,:,:,1)
     ENDWHERE
    ENDDO
  ELSE IF(HCARIN == '/EXPR7')THEN
    DO IPR=1,SIZE(XVAR,6)
     WHERE(XVAR(:,:,:,:,:,IPR) /= XSPVAL)
       XVAR(:,:,:,:,:,IPR)=XVAR(:,:,:,:,:,IPR)*XDEXPR7(:,:,:,:,:,1)
     ENDWHERE
    ENDDO
  ELSE IF(HCARIN == '/EXPR8')THEN
    DO IPR=1,SIZE(XVAR,6)
     WHERE(XVAR(:,:,:,:,:,IPR) /= XSPVAL)
       XVAR(:,:,:,:,:,IPR)=XVAR(:,:,:,:,:,IPR)*XDEXPR8(:,:,:,:,:,1)
     ENDWHERE
    ENDDO
  ELSE IF(HCARIN == '/EXPR9')THEN
    DO IPR=1,SIZE(XVAR,6)
     WHERE(XVAR(:,:,:,:,:,IPR) /= XSPVAL)
       XVAR(:,:,:,:,:,IPR)=XVAR(:,:,:,:,:,IPR)*XDEXPR9(:,:,:,:,:,1)
     ENDWHERE
    ENDDO
  ENDIF
ENDIF
RETURN

CONTAINS
       SUBROUTINE LOAD_EXPRX(PEXPR)
REAL,DIMENSION(:,:,:,:,:,:) :: PEXPR
REAL :: ZFAC

PEXPR(:,:,:,:,:,1)=XVAR(:,:,:,:,:,IP)
CALL ALLOC_FORDIACHRO(1,1,1,1,1,1,3)

IF(IMULT == 2)PEXPR=PEXPR*ZCONSTANTE
IF(IMULT == 1)PEXPR=PEXPR+ZCONSTANTE

IF(INDPLUS/=0 .OR. INDMINUS/=0) THEN
  IF (INDPLUS/=0) THEN
    YGROUP=YCARIN(INDPLUS+6:ILEN)
    ZFAC=1.
  ELSE IF (INDMINUS/=0) THEN
    YGROUP=YCARIN(INDPLUS+7:ILEN)
    ZFAC=-1.
  END IF
  CALL VERIF_GROUP(CFILEDIAS(JM),CLUOUTDIAS(JM),YGROUP)
  IF(LPBREAD)THEN
    LPBREAD=.FALSE.
    print *, ' ** load_expr PB avec le nom du groupe dans exprx',YGROUP
    IF(ALLOCATED(XVAR)) CALL ALLOC_FORDIACHRO(1,1,1,1,1,1,3)
    RETURN
  ENDIF
  IF(LGROUP)THEN
    CALL READ_DIACHRO(CFILEDIAS(JM),CLUOUTDIAS(JM),YGROUP)
  ENDIF
  IF(IP > SIZE(XVAR,6))THEN
    print *, ' ** load_expr PB avec le numero de processus :',IP, &
             ' > au nb de processus du groupe: ',SIZE(XVAR,6),'. Corrigez.'
    IF(ALLOCATED(XVAR)) CALL ALLOC_FORDIACHRO(1,1,1,1,1,1,3)
    RETURN
  ENDIF
  WHERE( (PEXPR(:,:,:,:,:,1) == XSPVAL) .OR. &
         (XVAR (:,:,:,:,:,IP) == XSPVAL)       )
    PEXPR(:,:,:,:,:,1)= XSPVAL
  ELSEWHERE
    PEXPR(:,:,:,:,:,1)=PEXPR(:,:,:,:,:,1)+ZFAC*XVAR(:,:,:,:,:,IP)
  ENDWHERE
  CALL ALLOC_FORDIACHRO(1,1,1,1,1,1,3)
ENDIF

END SUBROUTINE LOAD_EXPRX

       SUBROUTINE LOAD_EXPR1X(PEXPR)
REAL,DIMENSION(:,:,:,:,:,:) :: PEXPR
REAL :: ZFAC

PEXPR(:,:,:,:,:,1)=XVAR(:,:,:,:,:,IP)
CALL ALLOC_FORDIACHRO(1,1,1,1,1,1,3)

IF(IMULT == 2)THEN
  WHERE(PEXPR /= XSPVAL)
    PEXPR=PEXPR*ZCONSTANTE
  ENDWHERE
ELSEIF(IMULT == 1)THEN
  WHERE(XDEXPR1 /= XSPVAL)
    PEXPR=PEXPR+ZCONSTANTE
  ENDWHERE
ENDIF

IF(INDPLUS/=0 .OR. INDMINUS/=0) THEN
  IF (INDPLUS/=0) THEN
    YGROUP=YCARIN(INDPLUS+6:ILEN)
    ZFAC=1.
  ELSE IF (INDMINUS/=0) THEN
    YGROUP=YCARIN(INDPLUS+7:ILEN)
    ZFAC=-1.
  END IF
  CALL VERIF_GROUP(CFILEDIAS(JM),CLUOUTDIAS(JM),YGROUP)
  IF(LPBREAD)THEN
    LPBREAD=.FALSE.
    print *, ' ** load_expr PB avec le nom du groupe dans expr1x',YGROUP
    IF(ALLOCATED(XVAR)) CALL ALLOC_FORDIACHRO(1,1,1,1,1,1,3)
    RETURN
  ENDIF
  IF(LGROUP)THEN
    CALL READ_DIACHRO(CFILEDIAS(JM),CLUOUTDIAS(JM),YGROUP)
  ENDIF
  IF(IP > SIZE(XVAR,6))THEN
    print *, ' ** load_expr PB avec le numero de processus :',IP, &
             ' > au nb de processus du groupe: ',SIZE(XVAR,6),'. Corrigez.'
    IF(ALLOCATED(XVAR)) CALL ALLOC_FORDIACHRO(1,1,1,1,1,1,3)
    RETURN
  ENDIF
  WHERE( (PEXPR(:,:,:,:,:,1) == XSPVAL) .OR. &
         (XVAR (:,:,:,:,:,IP) == XSPVAL)       )
    PEXPR(:,:,:,:,:,1)= XSPVAL
  ELSEWHERE
    PEXPR(:,:,:,:,:,1)=PEXPR(:,:,:,:,:,1)+ZFAC*XVAR(:,:,:,:,:,IP)
  ENDWHERE
  CALL ALLOC_FORDIACHRO(1,1,1,1,1,1,3)
ENDIF

WHERE(PEXPR(:,:,:,:,:,1) /= XSPVAL .AND. PEXPR(:,:,:,:,:,1) /= 0.)
  PEXPR(:,:,:,:,:,1)=1./PEXPR(:,:,:,:,:,1)
ELSEWHERE
  PEXPR(:,:,:,:,:,1)=XSPVAL
ENDWHERE
END SUBROUTINE LOAD_EXPR1X

END SUBROUTINE LOAD_EXPR 

