!     ######spl
      SUBROUTINE READ_FILEHEAD(K,HFILEDIA,HLUOUTDIA)
!     ##############################################
!
!!****  *READ_FILEHEAD* - 
!!
!!    PURPOSE
!!    -------
!      
!
!!**  METHOD
!!    ------
!!     
!!     N.A.
!!
!!    EXTERNAL
!!    --------
!!      None
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!      Module
!!
!!    REFERENCE
!!    ---------
!!
!!
!!    AUTHOR
!!    ------
!!      J. Duron    * Laboratoire d'Aerologie *
!!
!!
!!    MODIFICATIONS
!!    -------------
!!      Original       08/01/96
!!      Updated   PM 
!-------------------------------------------------------------------------------
!
!*       0.    DECLARATIONS
!              ------------
!
USE MODD_DIACHRO
USE MODD_PARAMETERS
USE MODD_RESOLVCAR 
USE MODD_TYPE_AND_LH
USE MODD_DIM1
USE MODN_PARA
USE MODN_NCAR
USE MODI_FMREAD

IMPLICIT NONE
!
!*       0.1   Dummy arguments
!              ---------------

INTEGER          :: K
CHARACTER(LEN=*) :: HFILEDIA, HLUOUTDIA
!
!*       0.1   Local variables
!              ---------------

!
CHARACTER(LEN=16) :: YRECFM
CHARACTER(LEN=100) :: YCOMMENT
CHARACTER(LEN=16),DIMENSION(5000),SAVE    :: YGROUP 
INTEGER   ::   ILENG, ILENCH, IGRID, J, JJ, ILENDIM
INTEGER   ::   IRESPDIA
INTEGER,SAVE   ::   IGROUP=0
INTEGER,DIMENSION(:),ALLOCATABLE,SAVE :: ITABCHAR
INTEGER           :: IIINF, IJINF, IISUP, IJSUP
INTEGER           :: IMAX
REAL              :: ZIDEBCOU, ZJDEBCOU
LOGICAL        :: GDIMGRIDREF
!------------------------------------------------------------------------------
!

ILENDIM=1
YRECFM='MENU_BUDGET.DIM'
CALL FMREAD(HFILEDIA,YRECFM,HLUOUTDIA,ILENDIM,ILENG,&
IGRID,ILENCH,YCOMMENT,IRESPDIA)
IF (IRESPDIA .NE. 0) THEN
  print*,'-> le fichier ',TRIM(HFILEDIA),' n''est pas diachronique'
  print*,' (avez-vous fait conv2dia une fois pour traiter un fichier synchrone ?)'
  print*,' (ne pas appliquer conv2dia sur la sortie .000 du run)'
  STOP
END IF
ALLOCATE(ITABCHAR(ILENG))
YRECFM='MENU_BUDGET'
CALL FMREAD(HFILEDIA,YRECFM,HLUOUTDIA,ILENG,ITABCHAR, &
IGRID,ILENCH,YCOMMENT,IRESPDIA)
IGROUP=ILENG/16
!print *,' ILENG ILENCH IGROUP ',ILENG,ILENCH,IGROUP

DO JJ=1,IGROUP
  DO J = 1,16
    YGROUP(JJ)(J:J)=CHAR(ITABCHAR(16*(JJ-1)+J))
  ENDDO
ENDDO
DEALLOCATE(ITABCHAR)
GDIMGRIDREF=.FALSE.
DO JJ=1,IGROUP
! print *,' YGROUP :  ',YGROUP(JJ)
  YRECFM=ADJUSTL(ADJUSTR(YGROUP(JJ))//'.TYPE')
  ILENG=LEN(CTYPE)
  ALLOCATE(ITABCHAR(ILENG))
  CALL FMREAD(HFILEDIA,YRECFM,HLUOUTDIA,ILENG,ITABCHAR, &
  IGRID,ILENCH,YCOMMENT,IRESPDIA)
  DO J = 1,ILENG
    CTYPE(J:J) = CHAR(ITABCHAR(J))
  ENDDO
!66666666666666666666666666666666666666666666666666
! IF(CTYPE == 'CART' .OR. CTYPE == 'MASK' .OR. CTYPE == 'SPXY')THEN
!66666666666666666666666666666666666666666666666666
    GDIMGRIDREF=.TRUE.
!66666666666666666666666666666666666666666666666666
!   EXIT
! ENDIF
!66666666666666666666666666666666666666666666666666
  DEALLOCATE(ITABCHAR)
ENDDO

IF(GDIMGRIDREF)THEN
    IIINF=NIINF; IJINF=NJINF; IISUP=NISUP; IJSUP=NJSUP
    IF(NVERBIA > 0)THEN
    print *,' IIINF,IJINF,IISUP,IJSUP ',IIINF,IJINF,IISUP,IJSUP
    ENDIF
    ZIDEBCOU=XIDEBCOU; ZJDEBCOU=XJDEBCOU
    CALL INI_CST
    CALL FMREAD(HFILEDIA,'IMAX',HLUOUTDIA,1,IMAX,&
    IGRID,ILENCH,YCOMMENT,IRESPDIA)
    IF(IRESPDIA /= 0)THEN
      NIMAX=0
    ELSE
    CALL READ_DIMGRIDREF(K,HFILEDIA,HLUOUTDIA)
!   CALL INIDEF
!   NIMNMX=-1
!   LMINMAX=.TRUE.
!66666666666666666666666666666666666666666666666666
!   IF(NIMAX /= 0)THEN
!66666666666666666666666666666666666666666666666666
    CALL COMPCOORD_FORDIACHRO(0)
!66666666666666666666666666666666666666666666666666
    ENDIF
!66666666666666666666666666666666666666666666666666
    NIINF=IIINF; NJINF=IJINF; NISUP=IISUP; NJSUP=IJSUP
    XIDEBCOU=ZIDEBCOU; XJDEBCOU=ZJDEBCOU
ENDIF

!66666666666666666666666666666666666666666666666666
IF(ALLOCATED(ITABCHAR))THEN
  DEALLOCATE(ITABCHAR)
ENDIF
!66666666666666666666666666666666666666666666666666
!
!-----------------------------------------------------------------------------
!
!*       2.       EXITS
!                 -----
! 
RETURN
END SUBROUTINE READ_FILEHEAD
