!     ######spl
      MODULE MODI_READ_TYPE
!     #####################
!
INTERFACE
!
SUBROUTINE READ_TYPE(HFILEDIA,HLUOUTDIA,HGROUP)
CHARACTER(LEN=*) :: HFILEDIA, HLUOUTDIA, HGROUP
END SUBROUTINE READ_TYPE
!
END INTERFACE
END MODULE MODI_READ_TYPE
!     ###############################################
      SUBROUTINE READ_TYPE(HFILEDIA,HLUOUTDIA,HGROUP)
!     ###############################################
!
!!****  *READ_TYPE* - 
!!
!!    PURPOSE
!!    -------
!      
!
!!**  METHOD
!!    ------
!!     
!!     N.A.
!!
!!    EXTERNAL
!!    --------
!!      None
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!      Module
!!
!!    REFERENCE
!!    ---------
!!
!!
!!    AUTHOR
!!    ------
!!      J. Duron    * Laboratoire d'Aerologie *
!!
!!
!!    MODIFICATIONS
!!    -------------
!!      Original       08/01/97
!!      Updated   PM 
!-------------------------------------------------------------------------------
!
!*       0.    DECLARATIONS
!              ------------
!
USE MODD_DIACHRO
USE MODD_TYPE_AND_LH
USE MODD_SEVERAL_RECORDS
USE MODD_RESOLVCAR
USE MODD_ALLOC_FORDIACHRO
USE MODI_FMREAD

IMPLICIT NONE
!
!*       0.1   Dummy arguments
!              ---------------

CHARACTER(LEN=*) :: HFILEDIA, HLUOUTDIA, HGROUP
!
!*       0.1   Local variables
!              ---------------

!
CHARACTER(LEN=16) :: YRECFM
! Aout 99 longueur YCOMMENT passee de 20 a 100
CHARACTER(LEN=100) :: YCOMMENT
CHARACTER(LEN=LEN(HGROUP)) :: YGROUP
INTEGER   ::   ILENG, ILENCH, IGRID, J ,IL, ILS
INTEGER   ::   IRESPDIA
INTEGER,DIMENSION(:),ALLOCATABLE :: ITABCHAR
!------------------------------------------------------------------------------
!
LUMVM=.FALSE.; LMUMVM=.FALSE.; LULM=.FALSE.; LVTM=.FALSE.
LUTVT=.FALSE.; LMUTVT=.FALSE.; LULT=.FALSE.; LVTT=.FALSE.
LULMWM=.FALSE.; LULTWT=.FALSE.
LSUMVM=.FALSE.; LSUTVT=.FALSE.; LMLSUMVM=.FALSE.; LMLSUTVT=.FALSE.
LDIRWM=.FALSE.; LDIRWT=.FALSE.
YRECFM(1:LEN(YRECFM))=' '
LTYPE=.TRUE.
YGROUP=HGROUP
IL=LEN_TRIM(HGROUP)
ILS=INDEX(HGROUP,'LS')
IF(ILS == 0)THEN
!print *,' ENTREE read_type HGROUP ',HGROUP
  CALL READ_SUFWIND(YGROUP)
ELSE
  NSUFWIND=0
ENDIF
IF(NSUFWIND == 1)THEN
  HGROUP(IL:IL)=' '
ELSE IF(NSUFWIND == 2)THEN
  HGROUP(IL-1:IL)='  '
ENDIF

SELECT CASE(HGROUP)

  CASE('UMVM','MUMVM','ULM','VTM','DIRUMVM','DDUMVM')

    CALL VERIF_GROUP(HFILEDIA,HLUOUTDIA,'UM'//CSUFWIND)
    IF(LPBREAD)THEN
      LTYPE=.FALSE.
      print *,' GROUPE DEMANDE: ',YGROUP,' REQUETE IMPOSSIBLE '
      print *,' LA COMPOSANTE UM'//CSUFWIND,' N''EXISTE PAS '
      HGROUP=YGROUP
      RETURN
    ENDIF
    YRECFM='UM'//CSUFWIND
    CALL VERIF_GROUP(HFILEDIA,HLUOUTDIA,'VM'//CSUFWIND)
    IF(LPBREAD)THEN
      LTYPE=.FALSE.
      print *,' GROUPE DEMANDE: ',YGROUP,' REQUETE IMPOSSIBLE '
      print *,' LA COMPOSANTE VM'//CSUFWIND,' N''EXISTE PAS '
      HGROUP=YGROUP
      RETURN
    ENDIF
    YRECFM='VM'//CSUFWIND

    IF(HGROUP == 'UMVM')THEN
      LUMVM=.TRUE.
    ELSE IF(HGROUP == 'MUMVM')THEN
      LMUMVM=.TRUE.
    ELSE IF(HGROUP == 'ULM')THEN
      LULM=.TRUE.
    ELSE IF(HGROUP == 'VTM')THEN
      LVTM=.TRUE.
    ELSE IF(HGROUP == 'DIRUMVM')THEN
      LDIRWM=.TRUE.
      LDIRWIND=.TRUE.
    ELSE IF(HGROUP == 'DDUMVM')THEN
      LDIRWM=.TRUE.
    ENDIF

  YRECFM=ADJUSTL(ADJUSTR(YRECFM)//'.TYPE')

  CASE('LSUMVM','MLSUMVM')

    CALL VERIF_GROUP(HFILEDIA,HLUOUTDIA,'LSUM')
    IF(LPBREAD)THEN
      LTYPE=.FALSE.
      print *,' GROUPE DEMANDE: ',YGROUP,' REQUETE IMPOSSIBLE '
      print *,' LA COMPOSANTE LSUM N''EXISTE PAS '
      HGROUP=YGROUP
      RETURN
    ENDIF
    YRECFM='LSUM'
    CALL VERIF_GROUP(HFILEDIA,HLUOUTDIA,'LSVM')
    IF(LPBREAD)THEN
      LTYPE=.FALSE.
      print *,' GROUPE DEMANDE: ',YGROUP,' REQUETE IMPOSSIBLE '
      print *,' LA COMPOSANTE LSVM N''EXISTE PAS '
      HGROUP=YGROUP
      RETURN
    ENDIF
    YRECFM='LSVM'

    IF(HGROUP == 'LSUMVM')THEN
      LSUMVM=.TRUE.
    ELSE IF(HGROUP == 'MLSUMVM')THEN
      LMLSUMVM=.TRUE.
    ENDIF

  YRECFM=ADJUSTL(ADJUSTR(YRECFM)//'.TYPE')

  CASE('UTVT','MUTVT','ULT','VTT','DIRUTVT','DDUTVT')

    CALL VERIF_GROUP(HFILEDIA,HLUOUTDIA,'UT'//CSUFWIND)
    IF(LPBREAD)THEN
      LTYPE=.FALSE.
      print *,' GROUPE DEMANDE: ',YGROUP,' REQUETE IMPOSSIBLE '
      print *,' LA COMPOSANTE UT'//CSUFWIND,' N''EXISTE PAS '
      HGROUP=YGROUP
      RETURN
    ENDIF
    YRECFM='UT'//CSUFWIND
    CALL VERIF_GROUP(HFILEDIA,HLUOUTDIA,'VT'//CSUFWIND)
    IF(LPBREAD)THEN
      LTYPE=.FALSE.
      print *,' GROUPE DEMANDE: ',YGROUP,' REQUETE IMPOSSIBLE '
      print *,' LA COMPOSANTE VT'//CSUFWIND,' N''EXISTE PAS '
      HGROUP=YGROUP
      RETURN
    ENDIF
    YRECFM='VT'//CSUFWIND

    IF(HGROUP == 'UTVT')THEN
      LUTVT=.TRUE.
    ELSE IF(HGROUP == 'MUTVT')THEN
      LMUTVT=.TRUE.
    ELSE IF(HGROUP == 'ULT')THEN
      LULT=.TRUE.
    ELSE IF(HGROUP == 'VTT')THEN
      LVTT=.TRUE.
    ELSE IF(HGROUP == 'DIRUTVT')THEN
      LDIRWT=.TRUE.
      LDIRWIND=.TRUE.
    ELSE IF(HGROUP == 'DDUTVT')THEN
      LDIRWT=.TRUE.
    ENDIF

  YRECFM=ADJUSTL(ADJUSTR(YRECFM)//'.TYPE')

  CASE('LSUTVT','MLSUTVT')

    CALL VERIF_GROUP(HFILEDIA,HLUOUTDIA,'LSUT')
    IF(LPBREAD)THEN
      LTYPE=.FALSE.
      print *,' GROUPE DEMANDE: ',YGROUP,' REQUETE IMPOSSIBLE '
      print *,' LA COMPOSANTE LSUT N''EXISTE PAS '
      HGROUP=YGROUP
      RETURN
    ENDIF
    YRECFM='LSUT'
    CALL VERIF_GROUP(HFILEDIA,HLUOUTDIA,'LSVT')
    IF(LPBREAD)THEN
      LTYPE=.FALSE.
      print *,' GROUPE DEMANDE: ',YGROUP,' REQUETE IMPOSSIBLE '
      print *,' LA COMPOSANTE LSVT N''EXISTE PAS '
      HGROUP=YGROUP
      RETURN
    ENDIF
    YRECFM='LSVT'

    IF(HGROUP == 'LSUTVT')THEN
      LSUTVT=.TRUE.
    ELSE IF(HGROUP == 'MLSUTVT')THEN
      LMLSUTVT=.TRUE.
    ENDIF

  YRECFM=ADJUSTL(ADJUSTR(YRECFM)//'.TYPE')

  CASE('ULMWM')
    CALL VERIF_GROUP(HFILEDIA,HLUOUTDIA,'UM'//CSUFWIND)
    IF(LPBREAD)THEN
      LTYPE=.FALSE.
      print *,' GROUPE DEMANDE: ',YGROUP,' REQUETE IMPOSSIBLE '
      print *,' LA COMPOSANTE UM'//CSUFWIND,' N''EXISTE PAS '
      HGROUP=YGROUP
      RETURN
    ENDIF
    YRECFM='UM'//CSUFWIND
    CALL VERIF_GROUP(HFILEDIA,HLUOUTDIA,'VM'//CSUFWIND)
    IF(LPBREAD)THEN
      LTYPE=.FALSE.
      print *,' GROUPE DEMANDE: ',YGROUP,' REQUETE IMPOSSIBLE '
      print *,' LA COMPOSANTE VM'//CSUFWIND,' N''EXISTE PAS '
      HGROUP=YGROUP
      RETURN
    ENDIF
    YRECFM='VM'//CSUFWIND
    CALL VERIF_GROUP(HFILEDIA,HLUOUTDIA,'WM'//CSUFWIND)
    IF(LPBREAD)THEN
      LTYPE=.FALSE.
      print *,' GROUPE DEMANDE: ',YGROUP,' REQUETE IMPOSSIBLE '
      print *,' LA COMPOSANTE WM'//CSUFWIND,' N''EXISTE PAS '
      HGROUP=YGROUP
      RETURN
    ENDIF
    YRECFM='WM'//CSUFWIND
    
    LULMWM=.TRUE.

  YRECFM=ADJUSTL(ADJUSTR(YRECFM)//'.TYPE')

  CASE('ULTWT')
    CALL VERIF_GROUP(HFILEDIA,HLUOUTDIA,'UT'//CSUFWIND)
    IF(LPBREAD)THEN
      LTYPE=.FALSE.
      print *,' GROUPE DEMANDE: ',YGROUP,' REQUETE IMPOSSIBLE '
      print *,' LA COMPOSANTE UT'//CSUFWIND,' N''EXISTE PAS '
      HGROUP=YGROUP
      RETURN
    ENDIF
    YRECFM='UT'//CSUFWIND
    CALL VERIF_GROUP(HFILEDIA,HLUOUTDIA,'VT'//CSUFWIND)
    IF(LPBREAD)THEN
      LTYPE=.FALSE.
      print *,' GROUPE DEMANDE: ',YGROUP,' REQUETE IMPOSSIBLE '
      print *,' LA COMPOSANTE VT'//CSUFWIND,' N''EXISTE PAS '
      HGROUP=YGROUP
      RETURN
    ENDIF
    YRECFM='VT'//CSUFWIND
    CALL VERIF_GROUP(HFILEDIA,HLUOUTDIA,'WT'//CSUFWIND)
    IF(LPBREAD)THEN
      LTYPE=.FALSE.
      print *,' GROUPE DEMANDE: ',YGROUP,' REQUETE IMPOSSIBLE '
      print *,' LA COMPOSANTE WT'//CSUFWIND,' N''EXISTE PAS '
      HGROUP=YGROUP
      RETURN
    ENDIF
    YRECFM='WT'//CSUFWIND

    LULTWT=.TRUE.

  YRECFM=ADJUSTL(ADJUSTR(YRECFM)//'.TYPE')

  CASE DEFAULT

    CALL VERIF_GROUP(HFILEDIA,HLUOUTDIA,HGROUP)
    IF(LPBREAD)THEN
      LTYPE=.FALSE.
      HGROUP=YGROUP
      RETURN
    ENDIF
!   print *,' YGROUP :  ',HGROUP
    IF(LGROUP)THEN
      YRECFM=ADJUSTL(ADJUSTR(HGROUP)//'.TYPE')
    ELSE
      YRECFM=ADJUSTL(ADJUSTR(CGPNAM1)//'.TYPE')
    ENDIF
END SELECT
ILENG=LEN(CTYPE)
ALLOCATE(ITABCHAR(ILENG))
CALL FMREAD(HFILEDIA,YRECFM,HLUOUTDIA,ILENG,ITABCHAR, &
IGRID,ILENCH,YCOMMENT,IRESPDIA)
DO J = 1,ILENG
  CTYPE(J:J) = CHAR(ITABCHAR(J))
ENDDO
DEALLOCATE(ITABCHAR)

LTYPE=.FALSE.
!
!-----------------------------------------------------------------------------
!
!*       2.       EXITS
!                 -----
! 
!print *,' AV SORTIE HGROUP ',HGROUP
HGROUP=YGROUP
!print *,' SORTIE read_type HGROUP ',HGROUP
RETURN
END SUBROUTINE READ_TYPE
