!     ######spl
      MODULE MODI_REALLOC_AND_LOAD_RECORDS
!     ####################################
!
INTERFACE
!
SUBROUTINE REALLOC_AND_LOAD_RECORDS(HFILEDIA,HLUOUTDIA)
CHARACTER(LEN=*) :: HFILEDIA, HLUOUTDIA
END SUBROUTINE REALLOC_AND_LOAD_RECORDS
!
END INTERFACE
END MODULE MODI_REALLOC_AND_LOAD_RECORDS
!     ######spl
      SUBROUTINE REALLOC_AND_LOAD_RECORDS(HFILEDIA,HLUOUTDIA)
!     #######################################################
!
!!****  *REALLOC_AND_LOAD_RECORDS* - 
!!
!!    PURPOSE
!!    -------
!      
!
!!**  METHOD
!!    ------
!!     
!!     N.A.
!!
!!    EXTERNAL
!!    --------
!!      None
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!      Module
!!
!!      Module
!!
!!    REFERENCE
!!    ---------
!!
!!
!!    AUTHOR
!!    ------
!!      J. Duron    * Laboratoire d'Aerologie *
!!
!!
!!    MODIFICATIONS
!!    -------------
!!      Original       24/11/95
!!      Updated   PM   02/12/94
!-------------------------------------------------------------------------------
!
!*       0.    DECLARATIONS
!              ------------
!
USE MODD_ALLOC_FORDIACHRO
USE MODD_FILES_DIACHRO
USE MODD_RESOLVCAR
USE MODD_TYPE_AND_LH
USE MODD_SEVERAL_RECORDS

IMPLICIT NONE
!
!*       0.1   Dummy arguments
!              ---------------

CHARACTER(LEN=*) :: HFILEDIA, HLUOUTDIA

!
!*       0.1   Local variables
!              ---------------

INTEGER          :: J
INTEGER          :: II, IJ, IK,IT, IN, IP, IT1, IT2
INTEGER          :: IMODJ
INTEGER          :: INB, INAM

INTEGER,DIMENSION(:),ALLOCATABLE,SAVE    :: IGRIDIA

REAL,DIMENSION(:,:,:,:,:,:),ALLOCATABLE  :: ZVAR, ZVAR2
REAL,DIMENSION(:,:,:),ALLOCATABLE  :: ZTRAJX, ZTRAJX2
REAL,DIMENSION(:,:,:),ALLOCATABLE  :: ZTRAJY, ZTRAJY2
REAL,DIMENSION(:,:,:),ALLOCATABLE  :: ZTRAJZ, ZTRAJZ2
REAL,DIMENSION(:,:),ALLOCATABLE    :: ZTRAJT, ZTRAJT2
REAL,DIMENSION(:,:),ALLOCATABLE    :: ZDATIME, ZDATIME2
REAL,DIMENSION(:,:,:,:,:,:),ALLOCATABLE  :: ZMASK, ZMASK2
CHARACTER(LEN=16)  :: YNAM
CHARACTER(LEN=1)   :: YC1 
CHARACTER(LEN=2)   :: YC2 
CHARACTER(LEN=3)   :: YC3 
CHARACTER(LEN=4)   :: YC4 
CHARACTER(LEN=100),DIMENSION(:),ALLOCATABLE,SAVE  :: YTITRE
CHARACTER(LEN=100),DIMENSION(:),ALLOCATABLE,SAVE  :: YUNITE
CHARACTER(LEN=100),DIMENSION(:),ALLOCATABLE,SAVE  :: YCOMMENT

!------------------------------------------------------------------------------
IF(ALLOCATED(XVAR))THEN
  ALLOCATE(ZVAR(SIZE(XVAR,1),SIZE(XVAR,2),SIZE(XVAR,3),SIZE(XVAR,4), &
		SIZE(XVAR,5),SIZE(XVAR,6)))
  ZVAR(:,:,:,:,:,:)=XVAR(:,:,:,:,:,:)
ENDIF
IF(ALLOCATED(XTRAJT))THEN
  ALLOCATE(ZTRAJT(SIZE(XTRAJT,1),SIZE(XTRAJT,2)))
  ZTRAJT(:,:)=XTRAJT(:,:)
ENDIF
IF(ALLOCATED(XTRAJX))THEN
  ALLOCATE(ZTRAJX(SIZE(XTRAJX,1),SIZE(XTRAJX,2),SIZE(XTRAJX,3)))
  ZTRAJX(:,:,:)=XTRAJX(:,:,:)
ENDIF
IF(ALLOCATED(XTRAJY))THEN
  ALLOCATE(ZTRAJY(SIZE(XTRAJY,1),SIZE(XTRAJY,2),SIZE(XTRAJY,3)))
  ZTRAJY(:,:,:)=XTRAJY(:,:,:)
ENDIF
IF(ALLOCATED(XTRAJZ))THEN
  ALLOCATE(ZTRAJZ(SIZE(XTRAJZ,1),SIZE(XTRAJZ,2),SIZE(XTRAJZ,3)))
  ZTRAJZ(:,:,:)=XTRAJZ(:,:,:)
ENDIF
IF(ALLOCATED(XMASK))THEN
  ALLOCATE(ZMASK(SIZE(XMASK,1),SIZE(XMASK,2),SIZE(XMASK,3),SIZE(XMASK,4), &
		SIZE(XMASK,5),SIZE(XMASK,6)))
  ZMASK(:,:,:,:,:,:)=XMASK(:,:,:,:,:,:)
ENDIF
IF(ALLOCATED(NGRIDIA))THEN
  ALLOCATE(IGRIDIA(SIZE(NGRIDIA)))
  IGRIDIA(:)=NGRIDIA(:)
ENDIF
IF(ALLOCATED(CTITRE))THEN
  ALLOCATE(YTITRE(SIZE(CTITRE)))
  YTITRE=CTITRE
ENDIF
IF(ALLOCATED(CUNITE))THEN
  ALLOCATE(YUNITE(SIZE(CUNITE)))
  YUNITE=CUNITE
ENDIF
IF(ALLOCATED(CCOMMENT))THEN
  ALLOCATE(YCOMMENT(SIZE(CCOMMENT)))
  YCOMMENT=CCOMMENT
ENDIF
IF(ALLOCATED(XDATIME))THEN
  ALLOCATE(ZDATIME(SIZE(XDATIME,1),SIZE(XDATIME,2)))
  ZDATIME(:,:)=XDATIME(:,:)
ENDIF

CALL ALLOC_FORDIACHRO(1,1,1,1,1,1,3)

! Modifs 13/6/97
INB=(NAM2-NAM1)/NINCRNAM+1
IF(NVERBIA > 0)THEN
print *,' REALLOC_AND_LOAD... NAM1,NAM2,NINCRNAM,INB ', &
NAM1,NAM2,NINCRNAM,INB,CGPNAM1,' ',CGPNAM2
ENDIF
!INB=NAM2-NAM1+1
INAM=NAM1

IF(INB > 1)THEN

DO J=2,INB

! Modifs 13/6/97
INAM=INAM+NINCRNAM
!INAM=INAM+1
! Determination du nom du groupe
  SELECT CASE(NBCNUM)
    CASE(:1)
      IF(INAM < 10)THEN
	WRITE(YC1,'(I1)')INAM
	YNAM=ADJUSTL(ADJUSTR(CGPNAM)//YC1)
      ELSE IF(INAM < 100)THEN
	WRITE(YC2,'(I2)')INAM
	YNAM=ADJUSTL(ADJUSTR(CGPNAM)//YC2)
      ELSE IF(INAM < 1000)THEN
	WRITE(YC3,'(I3)')INAM
	YNAM=ADJUSTL(ADJUSTR(CGPNAM)//YC3)
      ELSE
	WRITE(YC4,'(I4)')INAM
	YNAM=ADJUSTL(ADJUSTR(CGPNAM)//YC4)
      ENDIF
    CASE(2)
      WRITE(YC2,'(I2.2)')INAM
      YNAM=ADJUSTL(ADJUSTR(CGPNAM)//YC2)
    CASE(3)
      WRITE(YC3,'(I3.3)')INAM
      YNAM=ADJUSTL(ADJUSTR(CGPNAM)//YC3)
    CASE(4)
      WRITE(YC4,'(I4.4)')INAM
      YNAM=ADJUSTL(ADJUSTR(CGPNAM)//YC4)
  END SELECT
! print *,' READ_AND_LOAD_RECORDS YNAM INAM  ',YNAM,INAM
  CALL READ_DIACHRO(HFILEDIA,HLUOUTDIA,YNAM)
  IMODJ=MOD(J,2)

  SELECT CASE(IMODJ)
    CASE(0)
      IF(ALLOCATED(XVAR))THEN
	IT1=SIZE(ZVAR,4);IT2=SIZE(XVAR,4)
	IT=IT1+IT2

        ALLOCATE(ZVAR2(SIZE(XVAR,1),SIZE(XVAR,2),SIZE(XVAR,3),IT, &
      		SIZE(XVAR,5),SIZE(XVAR,6)))
        ZVAR2(:,:,:,1:IT1,:,:)=ZVAR(:,:,:,1:IT1,:,:)
        ZVAR2(:,:,:,IT1+1:IT,:,:)=XVAR(:,:,:,:,:,:)
	DEALLOCATE(ZVAR)
      ENDIF
      IF(ALLOCATED(XTRAJT))THEN
        ALLOCATE(ZTRAJT2(IT,SIZE(XTRAJT,2)))
        ZTRAJT2(1:IT1,:)=ZTRAJT(1:IT1,:)
        ZTRAJT2(IT1+1:IT,:)=XTRAJT(:,:)
	DEALLOCATE(ZTRAJT)
      ENDIF
      IF(ALLOCATED(XTRAJX))THEN
        ALLOCATE(ZTRAJX2(SIZE(XTRAJX,1),IT,SIZE(XTRAJX,3)))
        ZTRAJX2(:,1:IT1,:)=ZTRAJX(:,1:IT1,:)
        ZTRAJX2(:,IT1+1:IT,:)=XTRAJX(:,:,:)
	DEALLOCATE(ZTRAJX)
      ENDIF
      IF(ALLOCATED(XTRAJY))THEN
        ALLOCATE(ZTRAJY2(SIZE(XTRAJY,1),IT,SIZE(XTRAJY,3)))
        ZTRAJY2(:,1:IT1,:)=ZTRAJY(:,1:IT1,:)
        ZTRAJY2(:,IT1+1:IT,:)=XTRAJY(:,:,:)
	DEALLOCATE(ZTRAJY)
      ENDIF
      IF(ALLOCATED(XTRAJZ))THEN
        ALLOCATE(ZTRAJZ2(SIZE(XTRAJZ,1),IT,SIZE(XTRAJZ,3)))
        ZTRAJZ2(:,1:IT1,:)=ZTRAJZ(:,1:IT1,:)
        ZTRAJZ2(:,IT1+1:IT,:)=XTRAJZ(:,:,:)
	DEALLOCATE(ZTRAJZ)
      ENDIF
      IF(ALLOCATED(XMASK))THEN
        ALLOCATE(ZMASK2(SIZE(XMASK,1),SIZE(XMASK,2),SIZE(XMASK,3),IT, &
      		SIZE(XMASK,5),SIZE(XMASK,6)))
        ZMASK2(:,:,:,1:IT1,:,:)=ZMASK(:,:,:,1:IT1,:,:)
        ZMASK2(:,:,:,IT1+1:IT,:,:)=XMASK(:,:,:,:,:,:)
	DEALLOCATE(ZMASK)
      ENDIF
      IF(ALLOCATED(XDATIME))THEN
        ALLOCATE(ZDATIME2(SIZE(XDATIME,1),IT))
        ZDATIME2(:,1:IT1)=ZDATIME(:,1:IT1)
        ZDATIME2(:,IT1+1:IT)=XDATIME(:,:)
	DEALLOCATE(ZDATIME)
      ENDIF
!     IF(ALLOCATED(CTITRE))THEN
!       ALLOCATE(YTITRE(SIZE(CTITRE)))
!       YTITRE=CTITRE
!     ENDIF
!     IF(ALLOCATED(CUNITE))THEN
!       ALLOCATE(YUNITE(SIZE(CUNITE)))
!       YUNITE=CUNITE
!     ENDIF
!     IF(ALLOCATED(CCOMMENT))THEN
!       ALLOCATE(YCOMMENT(SIZE(CCOMMENT)))
!       YCOMMENT=CCOMMENT
!     ENDIF

    CASE DEFAULT

      IF(ALLOCATED(XVAR))THEN
	IT1=SIZE(ZVAR2,4);IT2=SIZE(XVAR,4)
	IT=IT1+IT2

        ALLOCATE(ZVAR(SIZE(XVAR,1),SIZE(XVAR,2),SIZE(XVAR,3),IT, &
      		SIZE(XVAR,5),SIZE(XVAR,6)))
        ZVAR(:,:,:,1:IT1,:,:)=ZVAR2(:,:,:,1:IT1,:,:)
        ZVAR(:,:,:,IT1+1:IT,:,:)=XVAR(:,:,:,:,:,:)
	DEALLOCATE(ZVAR2)
      ENDIF
      IF(ALLOCATED(XTRAJT))THEN
        ALLOCATE(ZTRAJT(IT,SIZE(XTRAJT,2)))
        ZTRAJT(1:IT1,:)=ZTRAJT2(1:IT1,:)
        ZTRAJT(IT1+1:IT,:)=XTRAJT(:,:)
	DEALLOCATE(ZTRAJT2)
      ENDIF
      IF(ALLOCATED(XTRAJX))THEN
        ALLOCATE(ZTRAJX(SIZE(XTRAJX,1),IT,SIZE(XTRAJX,3)))
        ZTRAJX(:,1:IT1,:)=ZTRAJX2(:,1:IT1,:)
        ZTRAJX(:,IT1+1:IT,:)=XTRAJX(:,:,:)
	DEALLOCATE(ZTRAJX2)
      ENDIF
      IF(ALLOCATED(XTRAJY))THEN
        ALLOCATE(ZTRAJY(SIZE(XTRAJY,1),IT,SIZE(XTRAJY,3)))
        ZTRAJY(:,1:IT1,:)=ZTRAJY2(:,1:IT1,:)
        ZTRAJY(:,IT1+1:IT,:)=XTRAJY(:,:,:)
	DEALLOCATE(ZTRAJY2)
      ENDIF
      IF(ALLOCATED(XTRAJZ))THEN
        ALLOCATE(ZTRAJZ(SIZE(XTRAJZ,1),IT,SIZE(XTRAJZ,3)))
        ZTRAJZ(:,1:IT1,:)=ZTRAJZ2(:,1:IT1,:)
        ZTRAJZ(:,IT1+1:IT,:)=XTRAJZ(:,:,:)
	DEALLOCATE(ZTRAJZ2)
      ENDIF
      IF(ALLOCATED(XDATIME))THEN
        ALLOCATE(ZDATIME(SIZE(XDATIME,1),IT))
        ZDATIME(:,1:IT1)=ZDATIME2(:,1:IT1)
        ZDATIME(:,IT1+1:IT)=XDATIME(:,:)
	DEALLOCATE(ZDATIME2)
      ENDIF
      IF(ALLOCATED(XMASK))THEN
        ALLOCATE(ZMASK(SIZE(XMASK,1),SIZE(XMASK,2),SIZE(XMASK,3),IT, &
      		SIZE(XMASK,5),SIZE(XMASK,6)))
        ZMASK(:,:,:,1:IT1,:,:)=ZMASK2(:,:,:,1:IT1,:,:)
        ZMASK(:,:,:,IT1+1:IT,:,:)=XMASK(:,:,:,:,:,:)
	DEALLOCATE(ZMASK2)
      ENDIF

  END SELECT

  CALL ALLOC_FORDIACHRO(1,1,1,1,1,1,3)

ENDDO

ENDIF

IF(MOD(INB,2) == 0)THEN
  II=SIZE(ZVAR2,1); IJ=SIZE(ZVAR2,2); IK=SIZE(ZVAR2,3)
! IF(ALLOCATED(XMASK))THEN
  IF(CTYPE == 'MASK')THEN
    II=SIZE(ZMASK2,1); IJ=SIZE(ZMASK2,2)
  ENDIF
  IT=SIZE(ZVAR2,4); IN=SIZE(ZVAR2,5); IP=SIZE(ZVAR2,6)
ELSE
  II=SIZE(ZVAR,1); IJ=SIZE(ZVAR,2); IK=SIZE(ZVAR,3)
! IF(ALLOCATED(XMASK))THEN
  IF(CTYPE == 'MASK')THEN
    II=SIZE(ZMASK,1); IJ=SIZE(ZMASK,2)
  ENDIF
  IT=SIZE(ZVAR,4); IN=SIZE(ZVAR,5); IP=SIZE(ZVAR,6)
ENDIF

CALL ALLOC_FORDIACHRO(II,IJ,IK,IT,IN,IP,1)

IF(MOD(INB,2) == 0)THEN

  IF(ALLOCATED(XVAR))THEN
    XVAR(:,:,:,:,:,:)=ZVAR2(:,:,:,:,:,:)
    DEALLOCATE(ZVAR2)
  ENDIF
  IF(ALLOCATED(XTRAJT))THEN
    XTRAJT(:,:)=ZTRAJT2(:,:)
    DEALLOCATE(ZTRAJT2)
  ENDIF
  IF(ALLOCATED(XTRAJX))THEN
    XTRAJX(:,:,:)=ZTRAJX2(:,:,:)
    DEALLOCATE(ZTRAJX2)
  ENDIF
  IF(ALLOCATED(XTRAJY))THEN
    XTRAJY(:,:,:)=ZTRAJY2(:,:,:)
    DEALLOCATE(ZTRAJY2)
  ENDIF
  IF(ALLOCATED(XTRAJZ))THEN
    XTRAJZ(:,:,:)=ZTRAJZ2(:,:,:)
    DEALLOCATE(ZTRAJZ2)
  ENDIF
  IF(ALLOCATED(XMASK))THEN
    XMASK(:,:,:,:,:,:)=ZMASK2(:,:,:,:,:,:)
    DEALLOCATE(ZMASK2)
  ENDIF
  IF(ALLOCATED(XDATIME))THEN
    XDATIME(:,:)=ZDATIME2(:,:)
    DEALLOCATE(ZDATIME2)
  ENDIF

ELSE

  IF(ALLOCATED(XVAR))THEN
    XVAR(:,:,:,:,:,:)=ZVAR(:,:,:,:,:,:)
    DEALLOCATE(ZVAR)
  ENDIF
  IF(ALLOCATED(XTRAJT))THEN
    XTRAJT(:,:)=ZTRAJT(:,:)
    DEALLOCATE(ZTRAJT)
  ENDIF
  IF(ALLOCATED(XTRAJX))THEN
    XTRAJX(:,:,:)=ZTRAJX(:,:,:)
    DEALLOCATE(ZTRAJX)
  ENDIF
  IF(ALLOCATED(XTRAJY))THEN
    XTRAJY(:,:,:)=ZTRAJY(:,:,:)
    DEALLOCATE(ZTRAJY)
  ENDIF
  IF(ALLOCATED(XTRAJZ))THEN
    XTRAJZ(:,:,:)=ZTRAJZ(:,:,:)
    DEALLOCATE(ZTRAJZ)
  ENDIF
  IF(ALLOCATED(XMASK))THEN
    XMASK(:,:,:,:,:,:)=ZMASK(:,:,:,:,:,:)
    DEALLOCATE(ZMASK)
  ENDIF
  IF(ALLOCATED(XDATIME))THEN
    XDATIME(:,:)=ZDATIME(:,:)
    DEALLOCATE(ZDATIME)
  ENDIF

ENDIF
IF(ALLOCATED(NGRIDIA))THEN
  NGRIDIA=IGRIDIA
  DEALLOCATE(IGRIDIA)
ENDIF
IF(ALLOCATED(CTITRE))THEN
  CTITRE=YTITRE
  DEALLOCATE(YTITRE)
ENDIF
IF(ALLOCATED(CUNITE))THEN
  CUNITE=YUNITE
  DEALLOCATE(YUNITE)
ENDIF
IF(ALLOCATED(CCOMMENT))THEN
  CCOMMENT=YCOMMENT
  DEALLOCATE(YCOMMENT)
ENDIF

RETURN
END SUBROUTINE REALLOC_AND_LOAD_RECORDS  
